#include "script/common.lua"

pMessage = "Opening"
pDuration = 2

function init()
	closeDoor = false
	motor = FindJoint("motor")
	soundsource = FindLocation("soundsource")
	motorSound = LoadLoop("firewall-door-loop.ogg")
	motorStart = LoadSound("firewall-door-start.ogg")
	motorStop = LoadSound("firewall-door-stop.ogg")
	buttonClick = LoadSound("clickup.ogg")
	doortrigger = FindTrigger("doortrigger")
	openShape = FindShape("open")
	hackShape = FindShape("hack")
	playOnceStart = true
	playOnceEnd = true
	doorHeight = GetFloatParam("doorheight", 7)
	target = 0
	unlocked = false
	open = 1
	progress = 0
	hacked = false
	hackSnd = LoadLoop("transmission.ogg")
	motorOn = false
	ledTimer = 0
	SetShapeEmissiveScale(openShape, 0)
	SetTag(openShape, "interact", "Open")
end

function tick(dt)
	if GetPlayerInteractShape() == openShape and InputPressed("interact") then
		open = open + 1
		PlaySound(buttonClick, GetLocationTransform(soundsource).pos)
	end
	if math.mod(open, 2) < 0.5 then
		hacked = false
		SetTag(openShape, "interact", "Open")
		SetShapeEmissiveScale(openShape, 0)
	else
		hacked = true
		SetTag(openShape, "interact", "Close")
		SetShapeEmissiveScale(openShape, 1)
	end
	if not hacked then
		SetJointMotorTarget(motor, target, doorHeight*5, 3000)
		if GetPlayerInteractShape() == hackShape and InputDown("interact") then
			progress = progress + dt
			local t = clamp(progress / 2, 0, 1)
			if t == 1 then
				RemoveTag(hackShape, "interact")
				SetShapeEmissiveScale(hackShape, 0)
				PlaySound(motorStart,GetLocationTransform(soundsource).pos)
				hacked = true
				unlocked = true
			else
				SetBool("level.hacking", true)
				PlayLoop(hackSnd, GetShapeWorldTransform(hackShape).pos)
				SetShapeEmissiveScale(hackShape, math.sin(ledTimer) > 0.5 and 1 or 0)
			end
		else
			progress = 0
			SetShapeEmissiveScale(hackShape, math.sin(ledTimer) > 0.5 and 1 or 0)
		end
		ledTimer = ledTimer+dt*8
	end
	
	if GetBool("level.espionagealarm") and IsPointInTrigger(doortrigger, GetPlayerPos()) then
		if not closeDoor then
			closeDoor=true
			PlaySound(motorStart,GetLocationTransform(soundsource).pos)
		end
	end
	
	if not hacked or closeDoor or math.mod(open, 2) < 0.5 then
		target = doorHeight
	else
		target = 0
	end

	SetJointMotorTarget(motor, target, 1, 300000)

	if math.mod(open, 2) < 0.5 or not GetJointMovement(motor) == target then
		PlayLoop(motorSound,GetLocationTransform(soundsource).pos)
		motorOn = true
	else
		PlayLoop(motorSound,GetLocationTransform(soundsource).pos)
		if motorOn then
			PlaySound(motorStop,GetLocationTransform(soundsource).pos)
			motorOn = false
		end
	end
end


function draw()
	if not hacked and progress > 0 then
		UiPush()
			UiTranslate(UiCenter()-100, UiHeight()-220)
			progressBar(200, 20, progress/2)
			UiTranslate(100, -10)
			UiAlign("center")
			UiFont("bold.ttf", 24)
			UiText(pMessage)
		UiPop()
	end
end